﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SwapWithoutTempVariables
{
    class Program
    {
        static void Main(string[] args)
        {
            int a = 4, b = 8;
            Console.WriteLine("input a = " + a + ", b = " + b);
            RegularSwapUsingTempVariable(ref a, ref b);
            Console.WriteLine("output a = " + a + ", b = " + b);
            SwapWithoutTempVariable(ref a, ref b);
            Console.WriteLine("output a = " + a + ", b = " + b);
        }

        static void SwapWithoutTempVariable(ref int a, ref int b)
        {
            // first, set a to the difference a-b 
            a = a - b;
            // next, add b to the difference - thereby being left with a
            b = a + b;
            // now remove a from the original difference - leaving just b
            a = b - a;
        }

        static void RegularSwapUsingTempVariable(ref int a, ref int b)
        {
            int temp = a;
            a = b;
            b = temp;
        }
    }
}
